DH-EXEC(1)

NAME
dh-exec - Debhelper executable file helpers

SYNOPSIS
#! /usr/bin/dh-exec
src/libfoo-*.so.* debian/foo-plugins/usr/lib/foo/${DEB_HOST_MULTIARCH}/
etc/example.conf => debian/foo/etc/foo/foo.conf
[linux-any kfreebsd-any] some-arch-specific-file /usr/lib/foo/

DESCRIPTION
dh-exec is a simple program, meant to be used as the interpreter for executable debhelper config files. It is a wrapper around the various other sub-commands (see below), and will pipe the input file through all of them in turn, using an ordering that makes most sense in the vast majority of cases. The order as of now is dh-exec-subst gets run first, followed by dh-exec-install, so that variable expansion happens before files need to be copied.

FILTERING
In all dh-exec handled files, lines can be pre- or post-fixed with a list of architectures for which the rest of the line should apply to. All architectures and wildcards known by dpkg-architecture(1) are recognised, even negated ones.

ARCHITECTURE
dh-exec is built up from three layers: there is the dh-exec utility, its single entry point, the only thing one will need to call. Below that, there are the various sub-commands, such as dh-exec-subst, dh-exec-filter, dh-exec-install and dh-exec-illiterate, which are thin wrappers around the various dh-exec scripts, that make sure they only run those that need to be run. And the lowest layer are the various scripts that do the actual work. One can control which sub-commands to run, or if even more granularity is desired, one can limit which scripts shall be run, too. See below for the options!

OPTIONS

--with=command[,command ...]
    Replace the list of sub-commands to run the input through with a custom list (where entries are separated by whitespace or commas) that includes dh-exec-filter and dh-exec-strip at the start and end of the queue respectively. This option will always replace the existing list with whatever is specified. This can be used to explicitly set which sub-commands to use. The list must not include the dh-exec- prefix. Defaults to subst,install.

--without=command[,command ...]
    Inversely to the option above, this lists all the sub-commands which should not be used. The dh-exec-filter and dh-exec-strip subcommands cannot be removed using this option. Use the --no-defaults instead. The list must not include the dh-exec- prefix.

--with-scripts=script[,script ...]
    Replace the list of scripts to run the input through with a custom list (where entries are separated by whitespace or commas). This option will always replace the existing list with whatever is specified. This can be used to explicitly specify which scripts to use, limiting even beyond what the --with option is capable of. The list must not include the dh-exec- prefix. By default it is empty, meaning there is no filtering done, and whatever scripts the sub-commands find, will be run.

--no-defaults
    Most packages require the sub-command list to start with dh-exec-filter and end with dh-exec-strip subcommands. If you really want to, use this option to remove both these sub-commands. The --without option does not remove these two sub-commands.

--no-act
    Do not really do anything, but print the pipeline that would have been run instead.

--list
    List the available sub-commands and scripts, grouped by sub-command.

--help, --version
    Display a short help or the package version, respectively.

SUB-COMMANDS

dh-exec-subst
    Substitutes various variables (either from the environment, or from dpkg-architecture(1)).

dh-exec-filter
    Filters the input in various ways (architecture restrictions, build profiles, and so on).

dh-exec-install
    An extension to dh_install(1), that supports renaming files during the copy process, using a special syntax.

dh-exec-strip
    Removes unrequired lines such as comments or blank lines.

ENVIRONMENT

DH_EXEC_LIBDIR
    The directory in which the wrapped sub-commands reside. Defaults to /usr/lib/dh-exec/.

DH_EXEC_SCRIPTDIR
    The directory in which the scripts that do the heavy work live. Defaults to /usr/share/dh-exec/.

FILES

$DH_EXEC_LIBDIR/dh-exec-*
    The various sub-commands.

$DH_EXEC_SCRIPTDIR/dh-exec-*
    The various scripts ran by the sub-commands.

SEE ALSO
dh-exec-subst(1), dh-exec-filter(1), dh-exec-install(1), debhelper(7)